// KlaxSDL.cpp: Implementierung der Klasse CKlaxSDL.
//
//////////////////////////////////////////////////////////////////////

#include "KlaxSDL.h"

static CKlaxSDL* game;
void KlaxSDL_Menu_Player(int para)
{
	game->menu->menu->setElementActiv(para+8);
	game->create_player(para);
	game->menu->selectUMenu(0);
}

void KlaxSDL_Status(int para)
{
	game->status=(eStatus)para;
	game->menu->selectUMenu(0);
}

void KlaxSDL_Menu_HScore(int para)
{
	game->drawHighscore(para);
	game->status=HIGHSCORE;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
///////////////////////////////////////////////////////////////////////////////////////////////////

CKlaxSDL::CKlaxSDL()
{
	game=this;
	int i,j;
	// Variablen auf 0 setzen
	player.figur=0;
	highscore=0;
	screen=0;
	strichter=0;
	skorb=0;
	steine=0;

	status=MENU;

	for(i=0;i<5;i++)
		for(j=0;j<82;j++)
		trichter[i][j]=0;
	
	for(i=0;i<5;i++)
		for(j=0;j<5;j++)
			korb[i][j]=0;

	player.halter[0]=player.halter[1]=player.halter[2]=0;
	
	// die Grundeinstellungen
	einst.farben=3;
	einst.leben=3;
	einst.schw=0;
	einst.trichter=0;
	einst.versuche=5;
	einst.geschw=1;		// noch ohne funktion
}

CKlaxSDL::~CKlaxSDL()
{
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// Funktion fr die Initialisierung/Beenden des Spiels
///////////////////////////////////////////////////////////////////////////////////////////////////
void CKlaxSDL::init(byte schwierigkeit, byte player_color, bool fullscreen)
{
	int i=0;
	Uint32 flag=SDL_DOUBLEBUF|SDL_HWSURFACE;
	int farben=8;

	if(fullscreen)
	{
		flag|=SDL_FULLSCREEN;
		farben=8;
	}

	// Bildschirm erzeugen
	screen=SDL_SetVideoMode (SCREEN_BREITE, SCREEN_HOEHE, farben, flag);
	if(!screen)
	{
		fprintf(stderr,"Fehler bei Bildschirm init.!\n");
		exit(1);
	}

	// Titelleiste
	SDL_WM_SetCaption("KlaxSDL","KlaxSDL");

	// Spieler erzeugen
	create_player(player_color);

	// Steine laden
	SDL_Surface* tmp=SDL_LoadBMP("Data/steine.bmp");
	if(!tmp)
	{
		fprintf(stderr,"Konnte Data/steine.bmp nicht laden!\n");
		exit(2);
	}
	SDL_SetColorKey(tmp,SDL_SRCCOLORKEY,0);
	steine=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);

	// Rects fr die Steine
	for(i=0;i<8;i++)
	{
		reSt[i].w=steine->w;
		reSt[i].h=steine->h/8;
		reSt[i].x=0;
		reSt[i].y=i*16;
	}

	// Trichter laden
	tmp=SDL_LoadBMP("Data/trichter.bmp");
	if(!tmp)
	{
		fprintf(stderr,"Konnte Data/trichter.bmp nicht laden!\n");
		exit(2);
	}
	SDL_SetColorKey(tmp,SDL_SRCCOLORKEY,0);
	strichter=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);

	// Rects fr die Trichter
	for(i=0;i<3;i++)
	{
		reTr[i].w=strichter->w/3;
		reTr[i].h=strichter->h;
		reTr[i].y=0;
		reTr[i].x=i*(strichter->w/3);
	}

	for(i=0;i<5;i++)
	{
		reTrOut[i].w=strichter->w/3;
		reTrOut[i].h=strichter->h;
		reTrOut[i].y=FELD_TOP;
		reTrOut[i].x=FELD_LEFT+i*reTrOut[i].w+4*i;
	}

	// Korb laden
	tmp=SDL_LoadBMP("Data/korb.bmp");
	if(!tmp)
	{
		fprintf(stderr,"Konnte Data/korb.bmp nicht laden!\n");
		exit(2);
	}
	SDL_SetColorKey(tmp,SDL_SRCCOLORKEY,0);
	skorb=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);

	// Rect des Korbes
	reKorb.w=skorb->w;
	reKorb.h=skorb->h;
	reKorb.x=reTrOut[0].x - 8;
	reKorb.y=reTrOut[0].y+reTrOut[0].h + 8 + player.tiles[4].h + 16;

	// Zufallszahlen generator
	srand((unsigned)time(0));

	// HauptMen erzeugen
	menu = new CHauptMenu(screen,"Data/boulder.ttf");
	menu->menu->newTitel("K l a x S D L",MENU_TEXT_GROESE_STANDART*2,MENU_ZENTRIERT,30);
	menu->menu->newText("Start",MENU_ZENTRIERT,200);
	menu->menu->setElementAction(1,MENU_EACTION_UMENU,0,1);
	menu->menu->setElementActiv(1);
	menu->menu->newText("Einstellungen",MENU_ZENTRIERT,250);
	menu->menu->setElementAction(2,MENU_EACTION_UMENU,0,2);
	menu->menu->newText("Highscore",MENU_ZENTRIERT,300);
	menu->menu->setElementAction(3,MENU_EACTION_UMENU,0,3);
	menu->menu->newText("Beende",MENU_ZENTRIERT,350);
	menu->menu->setElementAction(4,&KlaxSDL_Status,SPIEL_EXIT);
	
	
	// Untermen Spiel Starten schwierigkeit
	menu->addUMenu();
	menu->menu->newRect(0,90,800,510,0,0,0);
	menu->menu->newTitel("Welche Schwierigkeits-Stufe?",MENU_TEXT_GROESE_STANDART,MENU_ZENTRIERT,100);
	menu->menu->newText("Einfach",MENU_ZENTRIERT,200);
	menu->menu->setElementAction(1,&KlaxSDL_Status,SPIEL_START);
	menu->menu->setElementActiv(1);
	menu->menu->newText("Mittel",MENU_ZENTRIERT,250);
	menu->menu->setElementAction(2,&KlaxSDL_Status,SPIEL_START);
	menu->menu->newText("Schwer",MENU_ZENTRIERT,300);
	menu->menu->setElementAction(3,&KlaxSDL_Status,SPIEL_START);
	menu->menu->newText("benutzerdef.",MENU_ZENTRIERT,350);
	menu->menu->setElementAction(4,&KlaxSDL_Status,SPIEL_START);

	// Untermem Einstellungen der Spielerfarbe
	menu->addUMenu();
	menu->menu->newRect(0,90,800,510,0,0,0);
	menu->menu->newTitel("Welche Spielerfarbe",MENU_TEXT_GROESE_STANDART,MENU_ZENTRIERT,100);
	menu->menu->newRect(300,203,90,30,255,0,0);
	menu->menu->newRect(300,253,90,30,0,255,0);
	menu->menu->newRect(300,303,90,30,0,0,255);
	menu->menu->newRect(300,353,90,30,255,255,0);
	menu->menu->newRect(300,403,90,30,255,0,255);
	menu->menu->newRect(300,453,90,30,0,255,255);
	menu->menu->newRect(300,503,90,30,255,255,255);
	menu->menu->newText("Rot",400,200);
	menu->menu->newText("Grn",400,250);
	menu->menu->newText("Blau",400,300);
	menu->menu->newText("Gelb",400,350);
	menu->menu->newText("Magenta",400,400);
	menu->menu->newText("Cyan",400,450);
	menu->menu->newText("Wei",400,500);
	menu->menu->setElementActiv(player_color+8);

	for(i=1;i<8;i++)
	{
		menu->menu->setElementAction(i,&KlaxSDL_Menu_Player,i-1);
		menu->menu->setElementAction(i+7,&KlaxSDL_Menu_Player,i-1);
	}

	// Untermen fr die HighScore
	menu->addUMenu();
	menu->menu->newRect(0,90,800,510,0,0,0);
	menu->menu->newTitel("Welche HighScore anzeigen",MENU_TEXT_GROESE_STANDART,MENU_ZENTRIERT,100);
	menu->menu->newText("Einfach",MENU_ZENTRIERT,200);
	menu->menu->setElementAction(1,&KlaxSDL_Menu_HScore,0);
	menu->menu->setElementActiv(1);
	menu->menu->newText("Mittel",MENU_ZENTRIERT,250);
	menu->menu->setElementAction(2,&KlaxSDL_Menu_HScore,1);
	menu->menu->newText("Schwer",MENU_ZENTRIERT,300);
	menu->menu->setElementAction(3,&KlaxSDL_Menu_HScore,2);
	menu->menu->newText("benutzerdef.",MENU_ZENTRIERT,350);
	menu->menu->setElementAction(4,&KlaxSDL_Menu_HScore,3);

	// Men zeichnen
	menu->zeichnen();
}

void CKlaxSDL::quit()
{
	if (highscore) SDL_FreeSurface(highscore);
	if (menu) delete menu;
	if (player.figur) SDL_FreeSurface(player.figur);
	if (strichter) SDL_FreeSurface(strichter);
	if (skorb) SDL_FreeSurface(skorb);
	if (steine) SDL_FreeSurface(steine);
}


///////////////////////////////////////////////////////////////////////////////////////////////////
// Wichtige Funktionen fr das Spielgeschehen
///////////////////////////////////////////////////////////////////////////////////////////////////
void CKlaxSDL::stein_ablegen()
{
	int y=4;

	// ist berhaupt noch was frei
	while(!korb[player.xpos][y] && y>=0) y--;

	if(y<4)
	{
		y++;
		korb[player.xpos][y]=player.halter[0];
	}
	else versuch_weg();

	// halter nachrcken
	player.halter[0]=player.halter[1];
	player.halter[1]=player.halter[2];
	player.halter[2]=0;

}

void CKlaxSDL::versuch_weg()
{


}

void CKlaxSDL::trichter_nachruecken()
{
	int i,j;
	int x=4;	// beim testen des Trichters (was da?)
	int y=2;	// beim testen des Spielers (noch platz?)
	
	// fngt der spieler den untersten stein?
	
	// wo ist ein stein?
	while(!trichter[x][81] && x>=0) x--;

	// stein da?
	if(x>=0)
	{
		// spieler an der richtigen Position
		if(x==player.xpos)
		{
			// hat der spieler noch platz
			while(!player.halter[y] && y>=0) y--;
			
			if(y<2)	// platz da
			{
				y++;
				player.halter[y]=trichter[x][81];
			}
			else versuch_weg();					

		}
		else versuch_weg();
	}


	// nachrcken
	for(i=0;i<5;i++)
	{
		for(j=81;j>0;j--)
			trichter[i][j]=trichter[i][j-1];
	
		// oberste reihe null
		trichter[i][0]=0;
	}
}

void CKlaxSDL::korb_testen()
{

}

void CKlaxSDL::korb_nachruecken()
{
	int y,i,j;
	for(i=0;i<5;i++)
		for(j=0;j<4;j++)
		{
			y=j;
			// is was ber dem Feld?
			while(!korb[i][y] && y<=5) y++;
			if(y>4) break;
			else
			{
				korb[i][j]=korb[i][y];
				korb[i][y]=0;
			}
		}
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// Eingabe Funktionen
///////////////////////////////////////////////////////////////////////////////////////////////////
void CKlaxSDL::click(Uint16 x, Uint16 y, Uint8 taste)
{
	switch (status)
	{
		case MENU:
			menu->click(x,y);
			zeichnen();
			break;

		case SPIEL_START:
			break;

		case SPIEL_ACTION:
			
			break;
		case SPIEL_ANI:
			
			break;
		case SPIEL_LOOS:
			
			break;
		case SPIEL_WIN:
			
			break;
		case HIGHSCORE:
			menu->selectUMenu(0);
			status=MENU;
			zeichnen();
			break;
	}

}

void CKlaxSDL::press(SDLKey taste, Uint16 unicode, bool down)
{
	char menu_taste=-1;
	if(!down) return;
			
	switch (status)
	{
		case MENU:
			switch(taste)
			{
			case SDLK_UP:
					menu_taste=MENU_TASTE_UP;
					break;
			case SDLK_DOWN:
					menu_taste=MENU_TASTE_DOWN;
					break;
			case SDLK_SPACE:
					menu_taste=MENU_TASTE_BACK;
					break;
			case SDLK_RETURN:
					menu_taste=MENU_TASTE_ACTION;
					break;
			}
			menu->keyPress(menu_taste);
			zeichnen();
			break;

		case SPIEL_START:
			
			break;
		case SPIEL_ACTION:
			switch(taste)
			{
			case SDLK_LEFT:
					if(player.xpos>0) player.xpos--;
					break;
			case SDLK_RIGHT:
					if(player.xpos<4) player.xpos++;
					break;
			case SDLK_DOWN:
			case SDLK_SPACE:
					status=SPIEL_ANI;
					break;
			}
			break;

		case SPIEL_ANI:
			if(!player.ani)
			{
				switch(taste)
				{
				case SDLK_LEFT:
						if(player.xpos>0) player.xpos--;
						break;
				case SDLK_RIGHT:
						if(player.xpos<4) player.xpos++;
						break;
				}
			}
			break;

		case SPIEL_LOOS:
			
			break;

		case SPIEL_WIN:
			
			break;

		case HIGHSCORE:
			menu->selectUMenu(0);
			status=MENU;
			zeichnen();
			break;
	}

}

///////////////////////////////////////////////////////////////////////////////////////////////////
// Zeichnen des Spiels
///////////////////////////////////////////////////////////////////////////////////////////////////
bool CKlaxSDL::tick()
{
	static unsigned int ticknr=0;	// damit sich die zeit besser bestimmen lst

	switch (status)
	{
		case MENU:
			break;
		case SPIEL_START:
			status=SPIEL_ACTION;
			zeichnen();
			break;
		case SPIEL_ACTION:
			trichter_nachruecken();
		
			// neue steine
			if(!(ticknr%50)) trichter[rand()%5][0]=1+rand()%8;

			ticknr++;
			
			// zeichnen
			zeichnen();
			break;

		case SPIEL_ANI:
			// Spieler animieren
			if(!player.anist) player.ani=true;
			if(player.ani) player.anist++;
			else player.anist--;
			if(player.anist==4)
			{
				stein_ablegen();
				player.ani=false;
			}
			else if(player.anist==0)
			{
				korb_testen();
				status=SPIEL_ACTION;
			}

			trichter_nachruecken();

			zeichnen();
			break;
		case SPIEL_LOOS:
			zeichnen();
			break;
		case SPIEL_WIN:
			zeichnen();
			break;
		case HIGHSCORE:
			break;
		case SPIEL_EXIT:
			return false;
	}

	return true;
}


///////////////////////////////////////////////////////////////////////////////////////////////////
// Zeichnen des Spiels
///////////////////////////////////////////////////////////////////////////////////////////////////
void CKlaxSDL::zeichnen()
{
	// alles Schwarz
	SDL_FillRect(screen,0,0);

	switch (status)
	{
		case MENU:
			menu->zeichnen();
			break;
		case SPIEL_START:
			
			break;
		case SPIEL_ACTION:
			draw_player();
			draw_steine();
			draw_spielfeld();
			break;
		case SPIEL_ANI:
			draw_player();
			draw_steine();
			draw_spielfeld();
			break;
		case SPIEL_LOOS:
			
			break;
		case SPIEL_WIN:
			
			break;
		case HIGHSCORE:
			SDL_BlitSurface(highscore,0,screen,0);
			break;
	}

	// Anzeigen
	SDL_Flip(screen);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// HighScore zeichnen
///////////////////////////////////////////////////////////////////////////////////////////////////
void CKlaxSDL::drawHighscore(int schw)
{
	// surface erzeugen
	if(highscore) SDL_FreeSurface(highscore);
	SDL_Surface* tmp=SDL_CreateRGBSurface(SDL_HWSURFACE,SCREEN_BREITE,SCREEN_HOEHE,8,0,0,0,0);
	highscore=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);

	CHighscore* hs=0;
	char titel[50]={0};

	switch(schw)
	{
		case 0: 
			hs = new CHighscore("Data/einfach.hsc",15);
			strcpy(titel,"Highscore (Einfach)");
			break;
		case 1:
			hs = new CHighscore("Data/mittel.hsc",15);
			strcpy(titel,"Highscore (Mittel)");
			break;
		case 2:
			hs = new CHighscore("Data/schwer.hsc",15);
			strcpy(titel,"Highscore (Schwer)");
			break;
		case 3:
			hs = new CHighscore("Data/benutzer.hsc",15);
			strcpy(titel,"Highscore (Benutzerd.)");
			break;
	}

	SDL_Surface* text;
	SDL_Rect pos={0};

	// alles Schwarz
	SDL_FillRect(highscore,0,0);

	// berschrifft
	text = CMenu::create_text(titel,40,CMenu::text_farbe_activ);
	pos.x= SCREEN_BREITE/2 - text->w/2;
	pos.y= 10;
	SDL_BlitSurface(text,0,highscore,&pos);
	SDL_FreeSurface(text);
	// Tabelle
	for(int i=0;i<15;i++)
	{	// Ranking
		text = CMenu::create_text(itoa(i+1,titel,10),25,CMenu::text_farbe_activ);
		pos.x= 210-text->w;
		pos.y= 70+i*32;
		SDL_BlitSurface(text,0,highscore,&pos);
		SDL_FreeSurface(text);

		// Namen
		strcpy(titel,hs->getName(i).c_str());
		text = CMenu::create_text(titel,30,CMenu::text_farbe_activ);
		pos.x= SCREEN_BREITE/2 - text->w/2;
		SDL_BlitSurface(text,0,highscore,&pos);
		SDL_FreeSurface(text);

		// Punkte
		text = CMenu::create_text(itoa(hs->getPunkte(i),titel,10),30,CMenu::text_farbe_activ);
		pos.x= 650 - text->w;
		SDL_BlitSurface(text,0,highscore,&pos);
		SDL_FreeSurface(text);
	}

	// fu
	text = CMenu::create_text("zurck zum Men",20,CMenu::text_farbe_activ);
	pos.x= SCREEN_BREITE/2 - text->w/2;
	pos.y= 575;
	SDL_BlitSurface(text,0,highscore,&pos);
	SDL_FreeSurface(text);

	// HighScore wieder freigeben
	delete hs;
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// Player Funktionen
///////////////////////////////////////////////////////////////////////////////////////////////////
void CKlaxSDL::create_player(byte color)
{
	if(player.figur) SDL_FreeSurface(player.figur);

	// Bild mit der Vorlage laden
	SDL_Surface* tmp=SDL_LoadBMP("Data/player.bmp");
	if(!tmp)
	{
		fprintf(stderr,"Konnte Data/Player.bmp nicht laden.\n");
		exit(1);
	}
	Uint32 keycolor=SDL_MapRGB(tmp->format,255,255,255);
	SDL_SetColorKey(tmp,SDL_SRCCOLORKEY,keycolor);
	SDL_Surface* vorlage=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	tmp=0;

	// Surface fr die farbige Vorlage erzeugen
	tmp=SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY,	vorlage->w, vorlage->h,
								8, 0, 0, 0, 0);

	SDL_SetColorKey(tmp,SDL_SRCCOLORKEY,0);
	SDL_Surface* farbige_vorlage=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	tmp=0;

	// Farben bestimmen
	Uint8 r,g,b;
	switch (color)
	{
		case 0: r=255; g=0;   b=0;   break;	// Rot
		case 1: r=0;   g=255; b=0;   break;	// Grn
		case 2: r=0;   g=0;   b=255; break; // Blau
		case 3: r=255; g=255; b=0;   break; // Gelb
		case 4: r=255; g=0;   b=255; break;	// Magenta
		case 5: r=0;   g=255; b=255; break; // Cyan
		default: r=255; g=255; b=255; break; // Wei
	}

	Uint32 farbe1=SDL_MapRGB(farbige_vorlage->format,r/2,g/2,b/2);
	Uint32 farbe2=SDL_MapRGB(farbige_vorlage->format,r,g,b);

	// Farben zeichnen
	SDL_Rect feld1={0,0,vorlage->w/2, vorlage->h};
	SDL_Rect feld2={vorlage->w/2,0,vorlage->w/2, vorlage->h};
	SDL_FillRect(farbige_vorlage,&feld1,farbe1);
	SDL_FillRect(farbige_vorlage,&feld2,farbe2);

	// Die Vorlage darber blitten
	SDL_BlitSurface(vorlage,0,farbige_vorlage,0);
	
	// Surface fr den Spieler Players
	tmp=SDL_CreateRGBSurface(SDL_SWSURFACE|SDL_SRCCOLORKEY,	vorlage->w/2, vorlage->h,
								8, 0, 0, 0, 0);

	SDL_SetColorKey(tmp,SDL_SRCCOLORKEY,0);
	player.figur=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);
	tmp=0;

	// Die fertige Surface erzeugen
	SDL_FillRect(player.figur,0,0);
	SDL_BlitSurface(farbige_vorlage,&feld1,player.figur,0);
	SDL_BlitSurface(farbige_vorlage,&feld2,player.figur,0);

	// benutzten Zwischenspeicher wieder freigeben
	SDL_FreeSurface (vorlage);
	SDL_FreeSurface (farbige_vorlage);

	// Halter auf 0 setzen
	player.halter[0]=player.halter[1]=player.halter[2]=0;

	// Position des Spielers setzen
	player.xpos=2;

	// aktuelle Animationstufe auf 0
	player.anist=0;
	player.ani=false;

	// tile_rects fllen
	for(int i=0;i<5;i++)
	{
		player.tiles[i].w=player.figur->w;
		player.tiles[i].h=32 + 8*i;
		player.tiles[i].x=0;
		if(!i) player.tiles[i].y=0;
		else player.tiles[i].y=player.tiles[i-1].y + player.tiles[i-1].h;
	}

	// standartwerte setzen
	player.versuche=10;
	player.leben=3;
}

void CKlaxSDL::draw_player()
{
	player.pos.w=player.figur->w;
	player.pos.h=player.tiles[player.anist].h;
	player.pos.y=reTrOut[0].y+reTrOut[0].h + 8 + player.tiles[4].h-player.tiles[player.anist].h;
	player.pos.x=reTrOut[player.xpos].x-16;

	SDL_BlitSurface(player.figur,&player.tiles[player.anist],screen,&player.pos);
}

///////////////////////////////////////////////////////////////////////////////////////////////////
// Zeichnen von Feld und Steinen
///////////////////////////////////////////////////////////////////////////////////////////////////
void CKlaxSDL::draw_spielfeld()
{
	// trichter zeichnen
	for(int i=0;i<5;i++)
		SDL_BlitSurface(strichter,&reTr[einst.trichter],screen,&reTrOut[i]);

	// Korb zeichnen
	SDL_BlitSurface(skorb,0,screen,&reKorb);

}

void CKlaxSDL::draw_steine()
{
	SDL_Rect ziel={0,0,steine->w,steine->h/8};
	int i,j;
	
	// steine des Trichters
	for(i=0;i<5;i++)
	{
		ziel.x=reTrOut[i].x+8;
		for(j=0;j<82;j++)
			if(trichter[i][j])
			{
				ziel.y=reTrOut[0].y+(j-2)*4;
				SDL_BlitSurface(steine,&reSt[trichter[i][j]-1],screen,&ziel);
			}
	}

	// steine des Spielers
	ziel.x=player.pos.x+24;
	for(i=0;i<3;i++)
		if(player.halter[i])
		{
			ziel.y=player.pos.y + player.pos.h - 16*(i+2);
			SDL_BlitSurface(steine,&reSt[player.halter[i]-1],screen,&ziel);
		}


	// Steine des Korbes
	for(i=0;i<5;i++)
	{
		ziel.x=reTrOut[i].x+8;
		for(j=0;j<5;j++)
			if(korb[i][j])
			{
				ziel.y=reKorb.y + 6 + (4-j)*16 + (4-j)*12;
				SDL_BlitSurface(steine,&reSt[korb[i][j]-1],screen,&ziel);
			}
	}
}
