// KlaxSDL.h: Schnittstelle fr die Klasse CKlaxSDL.
//
//////////////////////////////////////////////////////////////////////

#if !defined(KLAXSDL_HEADER)
#define KLAXSDL_HEADER

// Definitionen
#define SCREEN_BREITE	800
#define SCREEN_HOEHE	600
#define VOLLBILD		false
#define FELD_LEFT		25
#define FELD_TOP		20


// Includes
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <sdl.h>
#include <sdl_ttf.h>

#include "menu.h"
#include "CHighscore.h"

typedef unsigned char byte;
typedef enum
{
	MENU,
	SPIEL_START,
	SPIEL_ACTION,
	SPIEL_ANI,
	SPIEL_LOOS,
	SPIEL_WIN,
	HIGHSCORE,
	SPIEL_EXIT
} eStatus;


class CKlaxSDL  
{
public:
	CKlaxSDL();
	virtual ~CKlaxSDL();

	// Game Init/Exit
	void init(byte schwierigkeit=1, byte player_color=0, bool fullscreen=false);
	void quit();

	// Game eingabe
	void click(Uint16 x, Uint16 y, Uint8 taste);
	void press(SDLKey taste, Uint16 unicode, bool down);
	
	// Game anzeige/logik
	void zeichnen();
	bool tick();

	// Status des Spiels
	eStatus status;
	
	// Die Highscore zeichnen
	void drawHighscore(int schw);

	// erzeugt den Spieler in der gewnschten Farbe
	void create_player(byte color);	

	// Pointer zum Men
	CHauptMenu* menu;

private:
	SDL_Surface* screen;	// Bildschirmsurface
	SDL_Surface* steine;	// Surface der 8 Steine
	SDL_Rect reSt[8];		// die Rects der 8 verschiedenen steine
	SDL_Surface* strichter;	// surface der 3 verschiedenen Trichter
	SDL_Rect reTr[3];		// die Rects der drei Trichter in trichter.bmp
	SDL_Rect reTrOut[5];	// Das wo die trichter hinkommen
	SDL_Surface* skorb;		// Surface des Korbes
	SDL_Rect reKorb;		// Das wo der Korb hinsoll
	SDL_Surface* highscore;	// Surface der Highscore_anzeige

	struct strPlayer
	{
		byte halter[3];		// der Halter vom Spieler (die drei Steine)
		byte xpos;			// welche x position (0-4)
		SDL_Surface* figur;	// die Figur
		SDL_Rect tiles[5];	// das Rect fr die Tilesets
		SDL_Rect pos;		// das Aktuelle anzeigerect des Spielers
		byte anist;			// aktuelle Animationsstufe
		bool ani;			// luft gerad die animation
		byte versuche;		// noch mgliche versuche
		byte leben;			// noch brige leben
	} player;

	struct strEinst
	{
		byte farben;		// wieviel farben
		byte geschw;		// geschwiendigkeit
		byte leben;			// leben bei neustart
		byte versuche;		// versuche bei neustart
		byte schw;			// schwierigkeit
		byte trichter;		// welcher trichter wird verwendet
	} einst;
	
	// zeichnet den Spieler, das Spielfeld und die Steine
	void draw_player();	
	void draw_spielfeld();
	void draw_steine();

	// wichtige funktionen fr das spielgeschehen
	void trichter_nachruecken();
	void stein_ablegen();
	void versuch_weg();
	void korb_testen();
	void korb_nachruecken();

	// Wichtige Variablen fr das Spiel
	byte trichter[5][82];	// Obere Teil des Spielfeldes 
	byte korb[5][5];		// Untere Teil des Spielfeldes

};

#endif 
