#include "Menu.h"


// Standartwerte fr die Statichen Variblen in CMenu
SDL_Surface* CMenu::screen=0;
char CMenu::fontname[MENU_MAXLEN_FILENAME_FONT]={0};
SDL_Color CMenu::text_farbe_activ={200,0,0,0};
SDL_Color CMenu::text_farbe_inactiv={128,0,0,0};
SDL_Color CMenu::titel_farbe={255,0,0,0};

/**************************************************************************************
** CMenu_Element -> Standartklasse fr die einzelne Typen 
**************************************************************************************/
CHauptMenu* CMenu_Element::hm=0;
bool CMenu_Element::click(Uint16 x, Uint16 y)
{
	// click auf das Element?
	if((x>=pos.x)&&(y>=pos.y))
		if((x<=pos.x+pos.w)&&(y<=pos.y+pos.h))
		{
			// wenn es kein Text ist, und nicht activ, soll er nichts machen
			if((typ!=MENU_ETYP_TEXT) && (!activ)) return false;
			if(actionPara.atyp) action();
			return true;
		}
	return false;
}

int CMenu_Element::action()
{
	int tmp=0;
	switch (actionPara.atyp)
	{
		case MENU_EACTION_UMENU:
			hm->selectUMenu(actionPara.para);
			break;
		case MENU_EACTION_FUNKTION:
			(*actionPara.funkt)(actionPara.para);
			break;
	}

	return tmp;
}

void CMenu_Element::setAction(menu_action_funkt pfunkt, int para)
{
	// Parameter Speichern
	actionPara.atyp=MENU_EACTION_FUNKTION;
	actionPara.funkt=pfunkt;
	actionPara.para=para;
}

void CMenu_Element::setAction(char atyp, int flag, int para)
{
	// Parameter Speichern
	actionPara.atyp=atyp;
	actionPara.flag=flag;
	actionPara.para=para;
}

/**************************************************************************************
** CMenu_Element_Titel -> Ein einfacher Titel-Text 
**************************************************************************************/
CMenu_Element_Titel::CMenu_Element_Titel(short x, short y, char* text, unsigned char hight)
{
	// text in member_varibale speichern und lnge berprfen
	strncpy(this->text,text,MENU_MAXLEN_TITEL);

	// Surface mit dem Text erzeugen
	text_surf=CMenu::create_text(this->text,hight,CMenu::titel_farbe);
	
	// gre der Surface mit bernehmen
	pos.w=text_surf->w;
	pos.h=text_surf->h;

	// Positionieren
	if(x==MENU_ZENTRIERT) pos.x=CMenu::screen->w/2-pos.w/2; 
	else pos.x=x;
	if(y==MENU_ZENTRIERT) pos.y=CMenu::screen->h/50;
	else pos.y=y;
	
	// typ setzen
	typ=MENU_ETYP_TITEL;
	
	// activ setzen
	activ=true;
}

CMenu_Element_Titel::~CMenu_Element_Titel()
{
	// Surface wieder freigeben
	SDL_FreeSurface(text_surf);
}

void CMenu_Element_Titel::zeichnen()
{
	// Wenn das Element activ ist, dann zeichne es
	if(activ) SDL_BlitSurface(text_surf,0,CMenu::screen,&pos);
}

/**************************************************************************************
** CMenu_Element_Text -> Ein Text / Link 
**************************************************************************************/
CMenu_Element_Text::CMenu_Element_Text(short x, short y, char* text, unsigned char hight)
{
	// text in member_varibale speichern und lnge berprfen
	strncpy(this->text,text,MENU_MAXLEN_TITEL);

	// Surfaces mit dem Text erzeugen
	text_surf[0]=CMenu::create_text(this->text,hight,CMenu::text_farbe_inactiv);
	text_surf[1]=CMenu::create_text(this->text,hight,CMenu::text_farbe_activ);
	
	// gre der Surface mit bernehmen
	pos.w=text_surf[0]->w;
	pos.h=text_surf[0]->h;

	// Positionieren
	if(x==MENU_ZENTRIERT) pos.x=CMenu::screen->w/2-pos.w/2; 
	else pos.x=x;
	if(y==MENU_ZENTRIERT) pos.y=CMenu::screen->h/2-pos.h/2;
	else pos.y=y;

	// typ setzen
	typ=MENU_ETYP_TEXT;
	
	// nicht activ setzen
	activ=false;
}

CMenu_Element_Text::~CMenu_Element_Text()
{
	// Surfaces wieder freigeben
	SDL_FreeSurface(text_surf[0]);
	SDL_FreeSurface(text_surf[1]);
}

void CMenu_Element_Text::zeichnen()
{
	// wenn das Element activ ist zeichne Surf1 sonst Surf0
	if(activ) SDL_BlitSurface(text_surf[1],0,CMenu::screen,&pos);
	else SDL_BlitSurface(text_surf[0],0,CMenu::screen,&pos);
}

/**************************************************************************************
** CMenu_Element_Bild -> Ein Bild 
**************************************************************************************/
CMenu_Element_Bild::CMenu_Element_Bild(short x, short y, char* datei)
{
	// Surface mit dem bild laden
	SDL_Surface* tmp=0;
	tmp=SDL_LoadBMP(datei);
	bild=SDL_DisplayFormat(tmp);
	SDL_FreeSurface(tmp);

	// gre der Surface mit bernehmen
	pos.w=bild->w;
	pos.h=bild->h;

	// Positionieren
	if(x==MENU_ZENTRIERT) pos.x=CMenu::screen->w/2-pos.w/2; 
	else pos.x=x;
	if(y==MENU_ZENTRIERT) pos.y=CMenu::screen->h/2-pos.h/2;
	else pos.y=y;

	// typ setzen
	typ=MENU_ETYP_BILD;
	
	// activ setzen
	activ=true;
}

CMenu_Element_Bild::~CMenu_Element_Bild()
{
	// Surface wieder freigeben
	SDL_FreeSurface(bild);
}

void CMenu_Element_Bild::zeichnen()
{
	// Wenn das Element activ ist, dann zeichne es
	if(activ) SDL_BlitSurface(bild,0,CMenu::screen,&pos);
}

/**************************************************************************************
** CMenu_Element_Rect -> Ein Rechteck auf dem Bildschirm 
**************************************************************************************/
CMenu_Element_Rect::CMenu_Element_Rect(short x, short y, Uint16 w,Uint16 h, Uint8 r, Uint8 g, Uint8 b)
{
	// Positionieren
	if(x==MENU_ZENTRIERT) pos.x=CMenu::screen->w/2-w/2; 
	else pos.x=x;
	if(y==MENU_ZENTRIERT) pos.y=CMenu::screen->h/2-h/2;
	else pos.y=y;

	// gre
	pos.w=w;
	pos.h=h;

	// farbe bestimmen
	farbe=SDL_MapRGB(CMenu::screen->format,r,g,b);

	// typ setzen
	typ=MENU_ETYP_RECT;
	
	// activ setzen
	activ=true;
}

void CMenu_Element_Rect::zeichnen()
{
	// Wenn das Element activ ist, dann zeichne es
	if(activ) SDL_FillRect(CMenu::screen,&pos,farbe);
}


/**************************************************************************************
** CMenu -> Klasse fr ein einfaches standart Men 
**************************************************************************************/
CMenu::CMenu(SDL_Surface* pscreen, char* fontname)
{
	// grundinitialisierun
	hintbild=0;
	hintrect=0;
	titel=0;
	element_anz=0;
	element_activ=0;

	// werte speichern
	screen=pscreen;
	strncpy(CMenu::fontname,fontname,MENU_MAXLEN_FILENAME_FONT);
}

CMenu::~CMenu()
{
	// Elemente lschen
	if (hintbild>0) delete hintbild;
	if (hintrect>0) delete hintrect;
	if (titel>0) delete titel;

	if(element_anz>0)
	{
		for(;element_anz;element_anz--)
			delete element[element_anz-1];
	}
}

///////////////////////////////////////////////////////////////////////////////////////
// Zeichnen des Mens und seiner Elemente
///////////////////////////////////////////////////////////////////////////////////////
void CMenu::zeichnen()
{
	// die Hauptelement zeichen (wenn sie da sind)
	if (hintbild) hintbild->zeichnen();
	if (hintrect) hintrect->zeichnen();
	if (titel) titel->zeichnen();

	// die Elemente zeichnen
	for(int i=0;i<element_anz;i++)
		element[i]->zeichnen();
}

///////////////////////////////////////////////////////////////////////////////////////
// Klick in das Men, prfen der Elemente auf Klick
///////////////////////////////////////////////////////////////////////////////////////
char CMenu::click(Uint16 x, Uint16 y)
{
	int i,j;
	// die elemente auf click prfen
	for(i=0;i<element_anz;i++)
		if(element[i]->click(x,y))
		{
			// wenn es ein Text-Element ist, dieses activ schalten und alle anderen inactiv
			if(element[i]->getTyp()==MENU_ETYP_TEXT)
			{
				for(j=0;j<element_anz;j++)
					if(element[j]->getTyp()==MENU_ETYP_TEXT) element[j]->setActiv(false);
				element[i]->setActiv(true);
				element_activ=i+1;
			}
			zeichnen();
			return i+1;
		}
	
	return 0;
}


///////////////////////////////////////////////////////////////////////////////////////
// Mit den Tasten im Men bewegen
///////////////////////////////////////////////////////////////////////////////////////
char CMenu::keyPress(char menu_taste)
{
	int next_e=0;

	switch(menu_taste)
	{
	case MENU_TASTE_ACTION: element[element_activ-1]->action(); break;
	case MENU_TASTE_BACK: CMenu_Element::hm->selectUMenu(0); break;
	case MENU_TASTE_UP: 
		if(element_activ>1)
		{
			// was wre normal das nchste Textelement
			next_e=element_activ-1;
			// Das nchste textelement suchen
			while((element[next_e-1]->getTyp()!=MENU_ETYP_TEXT) && (next_e>0)) next_e--;
			// wenn es keins gibt, abbrechen
			if (!next_e) break;
			// altes text-Element inactiv, neues activ;
			element[element_activ-1]->setActiv(false);
			element[next_e-1]->setActiv(true);
			// neues actives Element merken und zurckgeben
			element_activ=next_e;
			return next_e;
		} break;
	case MENU_TASTE_DOWN:
		if(element_activ<element_anz)
		{
			// was wre normal das nchste Textelement
			next_e=element_activ+1;
			// Das nchste textelement suchen
			while((element[next_e-1]->getTyp()!=MENU_ETYP_TEXT) && (next_e<=element_anz)) next_e++;
			// wenn es keins gibt, abbrechen
			if (next_e>element_anz) break;
			// altes text-Element inactiv, neues activ;
			if(element_activ>0) element[element_activ-1]->setActiv(false);
			element[next_e-1]->setActiv(true);
			// neues actives Element merken, und zurckgeben
			element_activ=next_e;
			return next_e;
		} break;
	}

	zeichnen();
	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////
// Text_Element Activ setzen
///////////////////////////////////////////////////////////////////////////////////////
void CMenu::setElementActiv(char nr)
{
	if(nr>0&&nr<=element_anz) 
	{
		if(element_activ) element[element_activ-1]->setActiv(false);
		element_activ=nr;
		element[nr-1]->setActiv(true);
	}
}


///////////////////////////////////////////////////////////////////////////////////////
// Elemente zum Men hinzufgen
///////////////////////////////////////////////////////////////////////////////////////
int CMenu::newText(char* text, short x, short y, unsigned char hight)
{
	// darf ein Element hinzugefgt werden?
	if(element_anz<MENU_MAX_ELEMENTE)
	{
		// Element erzeugen
		element[element_anz] = new CMenu_Element_Text(x, y,text,hight);

		// berprfen
		if(element[element_anz]==0)
		{
			fprintf(stderr,"Konnte Text nicht Erzeugen!");
			return -1;
		}

		// merken das ein Element dazugekommen ist
		element_anz++;

		// Die Nr des Elements zurckgeben
		return element_anz;
	}
	else
	{
		fprintf(stderr,"Konnte Text nicht hinzufgen, keine Platz mehr!\n");
		return -1;
	}
}

int CMenu::newTitel(char* text,unsigned char hight, short x, short y)
{
	// Objekt erzeugen
	CMenu_Element_Titel* tmp = new CMenu_Element_Titel(x,y,text,hight);

	// Konnte es erzeugt werden
	if(tmp==0)
	{
		fprintf(stderr,"Konnte Titel nicht Erzeugen!");
		return -1;
	}
	
	// Zuweisen
	if(titel)
	{
		// darf ein Element hinzugefgt werden?
		if(element_anz<MENU_MAX_ELEMENTE)
		{
			element[element_anz] = tmp;
			element_anz++;
			// Die Nr des Elements zurckgeben
			return element_anz;
		}
		else
		{
			fprintf(stderr,"Konnte Titel nicht hinzufgen, kein Platz mehr!\n");
			delete tmp;
			return -1;
		}
	}
	else titel = tmp;

	return 0;
}

int CMenu::newBild(char* datei, short x, short y)
{
	// Objekt erzeugen
	CMenu_Element_Bild* tmp = new CMenu_Element_Bild(x,y,datei);

	// Konnte es erzeugt werden
	if(tmp==0)
	{
		fprintf(stderr,"Konnte Bild nicht Erzeugen!");
		return -1;
	}

	// Zuweisen
	if(hintbild)
	{
		// darf ein Element hinzugefgt werden?
		if(element_anz<MENU_MAX_ELEMENTE)
		{
			element[element_anz] = tmp;
			element_anz++;
			// Die Nr des Elements zurckgeben
			return element_anz;
		}
		else
		{
			fprintf(stderr,"Konnte Bild nicht hinzufgen, kein Platz mehr!\n");
			delete tmp;
			return -1;
		}
	}
	else hintbild = tmp;

	return 0;
}

int CMenu::newRect(short x, short y, Uint16 w,Uint16 h, Uint8 r, Uint8 g, Uint8 b)
{
	// Objekt erzeugen
	CMenu_Element_Rect* tmp = new CMenu_Element_Rect(x,y,w,h,r,g,b);

	// Konnte es erzeugt werden
	if(tmp==0)
	{
		fprintf(stderr,"Konnte Rect nicht Erzeugen!");
		return -1;
	}

	// Zuweisen
	if(hintrect)
	{
		// darf ein Element hinzugefgt werden?
		if(element_anz<MENU_MAX_ELEMENTE)
		{
			element[element_anz] = tmp;
			element_anz++;
			// Die Nr des Elements zurckgeben
			return element_anz;
		}
		else
		{
			fprintf(stderr,"Konnte Rect nicht hinzufgen, kein Platz mehr!\n");
			delete tmp;
			return -1;
		}
	}
	else hintrect = tmp;

	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////
// seinem Element eine Aktion zuweisen
///////////////////////////////////////////////////////////////////////////////////////
void CMenu::setElementAction(int nr, menu_action_funkt pfunkt, int para)
{	
	if(nr>0&&nr<=element_anz) element[nr-1]->setAction(pfunkt, para);
}

void CMenu::setElementAction(int nr, char atyp, int flag, int para)
{
	if(nr>0&&nr<=element_anz) element[nr-1]->setAction(atyp, flag, para);
}

///////////////////////////////////////////////////////////////////////////////////////
// statische Funktion zum erzeugen einer Textsurface
///////////////////////////////////////////////////////////////////////////////////////
SDL_Surface* CMenu::create_text(char* text, unsigned char hight, SDL_Color tfarbe)
{
	// bentigte variablen
	SDL_Surface* tmp=0;
	TTF_Font* font=0;
	bool SDL_TTF_on=false;

	// berprft ob berhaupt ein Text angegeben ist
	if(text[0]<32) return 0;
	
	// berprft ob SDL_TTF schon luft
	if(TTF_WasInit()) SDL_TTF_on=true;
	else TTF_Init();

	// Font ffnen
	font = TTF_OpenFont(fontname, hight);

	// mit der Font zeichnen (in der standartfarben)
	tmp = TTF_RenderText_Blended(font,text,tfarbe);

	// font schlieen
	TTF_CloseFont(font);

	// SDL_TTF schlieen
	if(!SDL_TTF_on) TTF_Quit();

	// pointer der text_surface zrckgeben
	return tmp;
}

///////////////////////////////////////////////////////////////////////////////////////
// statische funktionenen zum beeinflussen der textParameter
///////////////////////////////////////////////////////////////////////////////////////
void CMenu::setColor_text_activ(Uint8 r,Uint8 g,Uint8 b)
{
	text_farbe_activ.r=r;
	text_farbe_activ.g=g;
	text_farbe_activ.b=b;
}
void CMenu::setColor_text_inactiv(Uint8 r,Uint8 g,Uint8 b)
{
	text_farbe_inactiv.r=r;
	text_farbe_inactiv.g=g;
	text_farbe_inactiv.b=b;
}
void CMenu::setColor_titel(Uint8 r,Uint8 g,Uint8 b)
{
	titel_farbe.r=r;
	titel_farbe.g=g;
	titel_farbe.b=b;
}


/**************************************************************************************
** CHauptMenu -> Klasse fr ein Sammlung von Men 
**************************************************************************************/
CHauptMenu::CHauptMenu(SDL_Surface* pscreen, char* fontname)
{
	// Pointer zu diesem Menu in CMenu_Elemente speichern -> fr ElementAction
	CMenu_Element::hm=this;

	// grundinitialisierun
	act_umenu=0;
	anz_umenu=0;

	// werte speichern
	CMenu::screen=pscreen;
	strncpy(CMenu::fontname,fontname,MENU_MAXLEN_FILENAME_FONT);

	// das Hauptmen erzeugen
	addUMenu();
}

CHauptMenu::~CHauptMenu()
{
	for(anz_umenu--;anz_umenu>=0;anz_umenu--)
		delete umenu[anz_umenu];
}

///////////////////////////////////////////////////////////////////////////////////////
// Aktionen an das Active Unterme weiterleiten
///////////////////////////////////////////////////////////////////////////////////////
void CHauptMenu::zeichnen()
{
	// hauptmen zeichnen
	umenu[0]->zeichnen();

	// wenn ein UMen activ, dann das zeichnen
	if(act_umenu) umenu[act_umenu]->zeichnen();
}

char CHauptMenu::click(Uint16 x, Uint16 y)
{
	char tmp;
	// als erstes das Active UMen testen
	tmp=umenu[act_umenu]->click(x,y);
	if(tmp) return tmp;

	// wenn es nicht erfolgreich war das Hauptmen testen
	return umenu[0]->click(x,y);
}

char CHauptMenu::keyPress(char menu_taste)
{
	umenu[act_umenu]->keyPress(menu_taste);
	zeichnen();
	return 0;
}

///////////////////////////////////////////////////////////////////////////////////////
// Ein Untermen erzeugen
///////////////////////////////////////////////////////////////////////////////////////
int CHauptMenu::addUMenu()
{
	if(anz_umenu<MENU_MAX_UMENU+1)
	{
		umenu[anz_umenu]= new CMenu(CMenu::screen,CMenu::fontname);
		if(umenu[anz_umenu])
		{
			menu=umenu[anz_umenu];
			anz_umenu++;
			return anz_umenu-1;
		}
		else
		{
			fprintf(stderr,"Konnte Untermen nicht erzeugen.");
			return 0;
		}
	}
	else
	{
		fprintf(stderr,"Konnte Untermen nicht erzeugen. Es sind zu viele.");
		return 0;
	}
}