#include <stdlib.h>
#include <stdio.h>
#include <sdl.h>
#include <sdl_ttf.h>

#include "KlaxSDL.h"

#define GAME_LOGIK_FRAMES	25		// FPS des Spiels


int main(int argc, char **argv)
{
	if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO)<0)		// Initialiserung von SDL
	{
		fprintf(stderr,"SDL konnte nicht initialisiert werden: %s\n",SDL_GetError());
		exit(1);
	}

	if(TTF_Init()==-1) // Initialiserung von TTF
	{
		fprintf(stderr,"SDL_ttf konnte nicht initialisiert werden: %s\n", TTF_GetError());
		exit(1);
	}
	
	// Titel und Icon setzten
	SDL_WM_SetCaption("SDL_Game","SDL_Game");
	//SDL_WM_SetIcon(SDL_LoadBMP("Data/icon.bmp"), NULL);

	// Unicode einschalten
	SDL_EnableUNICODE(1);

	// Game initiieren und starten
	CKlaxSDL game;
	game.init(1,1);

	// Programmlogik (Eventbehandlung)
	bool running = true;
	while (running)
	{
		SDL_Event event;
		while(SDL_PollEvent(&event))
		{
			switch(event.type)
			{
			case SDL_KEYDOWN:
				if (event.key.keysym.sym==SDLK_ESCAPE)
					running=false;
				else
					game.press(event.key.keysym.sym,event.key.keysym.unicode,1);
				break;
			case SDL_KEYUP:
				game.press(event.key.keysym.sym,event.key.keysym.unicode,0);
				break;

			case SDL_MOUSEBUTTONDOWN:
				game.click(event.button.x, event.button.y, event.button.button);
				break;

			case SDL_QUIT:
				running = false;
				break;

			}
		}
		
		if(!running) break;

		// spiel mit 25 FPS ausfhren, wenn es aktiv ist
		static Uint32 starttime=SDL_GetTicks();
		static Uint32 maxtime=1000/GAME_LOGIK_FRAMES;
		if((SDL_GetAppState()&SDL_APPINPUTFOCUS)==SDL_APPINPUTFOCUS)
		{
			if((SDL_GetTicks()-starttime)>=maxtime)
			{
				running=game.tick();
				starttime=SDL_GetTicks();
			}
		}
	}

	// Spiel beenden
	game.quit();

	// TTF beenden
	TTF_Quit();

	// SDL beenden
	SDL_Quit();
	return 0;
}
